##// END OF EJS Templates
increase firmware partition from 64M to 128M
Chris Jackson -
r755:8640a033f486
parent child
Show More
@@ -1,920 +1,920
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=3P}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47 if [ $RELEASE = "bullseye" ] ; then
48 48 RELEASE=testing
49 49 fi
50 50
51 51 # Kernel Branch
52 52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 53
54 54 # URLs
55 55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64 64
65 65 # Kernel deb packages for 32bit kernel
66 66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
70 70 # Default precompiled 64bit kernel
71 71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
72 72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
74 74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
76 76 # Generic
77 77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81 81
82 82 # Build directories
83 83 WORKDIR=$(pwd)
84 84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 85 BUILDDIR="${BASEDIR}/build"
86 86
87 87 # Chroot directories
88 88 R="${BUILDDIR}/chroot"
89 89 ETC_DIR="${R}/etc"
90 90 LIB_DIR="${R}/lib"
91 91 BOOT_DIR="${R}/boot/firmware"
92 92 KERNEL_DIR="${R}/usr/src/linux"
93 93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95 95
96 96 # APT settings
97 97 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
98 98 APT_PROXY=${APT_PROXY:=""}
99 99 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
100 100 # Packages required in the chroot build environment
101 101 APT_INCLUDES=${APT_INCLUDES:=""}
102 102 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
103 103 # Packages to exclude from chroot build environment
104 104 APT_EXCLUDES=${APT_EXCLUDES:=""}
105 105
106 106 # General settings
107 107 SET_ARCH=${SET_ARCH:=32}
108 108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
109 109 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
110 110 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
111 111 EXPANDROOT=${EXPANDROOT:=true}
112 112
113 113 ENABLE_ROOT=${ENABLE_ROOT:=false}
114 114 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
115 115 ENABLE_USER=${ENABLE_USER:=true}
116 116 USER_NAME=${USER_NAME:="pi"}
117 117 USER_PASSWORD=${USER_PASSWORD:=raspberry}
118 118
119 119 # Keyboard settings
120 120 XKB_MODEL=${XKB_MODEL:=""}
121 121 XKB_LAYOUT=${XKB_LAYOUT:=""}
122 122 XKB_VARIANT=${XKB_VARIANT:=""}
123 123 XKB_OPTIONS=${XKB_OPTIONS:=""}
124 124
125 125 # Networking settings:
126 126 ENABLE_IPV6=${ENABLE_IPV6:=true}
127 127 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 128 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
129 129 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
130 130 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
131 131
132 132 # Network settings (DHCP)
133 133 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
134 134 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
135 135
136 136 # Network settings (static)
137 137 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
138 138 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
139 139 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
140 140 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
141 141 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
142 142 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
143 143 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
144 144
145 145 # Networking settings (WIFI):
146 146 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
147 147 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
148 148
149 149 # Network settings (static)
150 150 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
151 151 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
152 152 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
153 153 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
154 154 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
155 155 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
156 156 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
157 157
158 158 # Feature settings
159 159 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
160 160 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
161 161 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
162 162 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
163 163 ENABLE_TURBO=${ENABLE_TURBO:=false}
164 164 ENABLE_I2C=${ENABLE_I2C:=false}
165 165 ENABLE_SPI=${ENABLE_SPI:=false}
166 166
167 167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
168 168 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
169 169 ENABLE_SOUND=${ENABLE_SOUND:=false}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
175 175 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
176 176 ENABLE_LOGO=${ENABLE_LOGO:=true}
177 177 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
178 178 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
179 179
180 180 # Advanced settings
181 181 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
182 182 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
183 183 ENABLE_QEMU=${ENABLE_QEMU:=false}
184 184 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
185 185 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
186 186 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
187 187 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
188 188 ENABLE_DBUS=${ENABLE_DBUS:=true}
189 189 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
190 190 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
191 191 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 192 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 193 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 194 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
195 195 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
196 196 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
197 197 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
198 198 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
199 199
200 200 # SSH settings
201 201 SSH_ENABLE=${SSH_ENABLE:=true}
202 202 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
203 203 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
204 204 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
205 205 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
206 206 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
207 207
208 208 # Kernel compilation settings
209 209 BUILD_KERNEL=${BUILD_KERNEL:=true}
210 210 KERNEL_THREADS=${KERNEL_THREADS:=1}
211 211 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
212 212 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
213 213 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
214 214 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
215 215 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
216 216 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
217 217 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
218 218 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
219 219 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
220 220 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
221 221 # Firmware directory: Blank if download from github
222 222 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
223 223 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
224 224 KERNEL_NF=${KERNEL_NF:=false}
225 225 KERNEL_VIRT=${KERNEL_VIRT:=false}
226 226 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
227 227 KERNEL_BPF=${KERNEL_BPF:=false}
228 228 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
229 229 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
230 230 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
231 231 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
232 232 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
233 233
234 234 # Reduce disk usage settings
235 235 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
236 236 REDUCE_APT=${REDUCE_APT:=true}
237 237 REDUCE_DOC=${REDUCE_DOC:=false}
238 238 REDUCE_MAN=${REDUCE_MAN:=false}
239 239 REDUCE_VIM=${REDUCE_VIM:=false}
240 240 REDUCE_BASH=${REDUCE_BASH:=false}
241 241 REDUCE_HWDB=${REDUCE_HWDB:=false}
242 242 REDUCE_SSHD=${REDUCE_SSHD:=false}
243 243 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
244 244 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
245 245
246 246 # Encrypted filesystem settings
247 247 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
248 248 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
249 249 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
250 250 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
251 251 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
252 252 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
253 253 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
254 254 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
255 255 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
256 256 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
257 257
258 258 # Packages required for bootstrapping
259 259 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
260 260 MISSING_PACKAGES=""
261 261
262 262 # Packages installed for c/c++ build environment in chroot (keep empty)
263 263 COMPILER_PACKAGES=""
264 264
265 265 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
266 266 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
267 267 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
268 268 APT_PROXY=http://127.0.0.1:3142/
269 269 fi
270 270
271 271 # Setup architecture specific settings
272 272 if [ -n "$SET_ARCH" ] ; then
273 273 # 64-bit configuration
274 274 if [ "$SET_ARCH" = 64 ] ; then
275 275 # General 64-bit depended settings
276 276 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
277 277 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
278 278 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
279 279
280 280 # Raspberry Pi model specific settings
281 281 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
282 282 if [ "$RPI_MODEL" != 4 ] ; then
283 283 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
284 284 else
285 285 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
286 286 fi
287 287
288 288 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
289 289 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
290 290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
291 291 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
292 292 else
293 293 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
294 294 exit 1
295 295 fi
296 296 fi
297 297
298 298 # 32-bit configuration
299 299 if [ "$SET_ARCH" = 32 ] ; then
300 300 # General 32-bit dependend settings
301 301 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
302 302 KERNEL_ARCH=${KERNEL_ARCH:=arm}
303 303 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
304 304
305 305 # Raspberry Pi model specific settings
306 306 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
307 307 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
308 308 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
309 309 RELEASE_ARCH=${RELEASE_ARCH:=armel}
310 310 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
311 311 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
312 312
313 313 if [ $ENABLE_XORG = true ] ; then
314 314 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
315 315 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
316 316 read -r confirm
317 317 if [ "$confirm" = "y" ] ; then
318 318 $RELEASE = "stretch"
319 319 fi
320 320 fi
321 321 fi
322 322 fi
323 323 # Raspberry Pi model specific settings
324 324 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
325 325 if [ "$RPI_MODEL" != 4 ] ; then
326 326 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
327 327 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
328 328 else
329 329 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
330 330 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
331 331 fi
332 332
333 333 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
334 334 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
335 335
336 336 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
337 337 fi
338 338 fi
339 339 # SET_ARCH not set
340 340 else
341 341 echo "error: Please set '32' or '64' as value for SET_ARCH"
342 342 exit 1
343 343 fi
344 344 # Device specific configuration and U-Boot configuration
345 345 case "$RPI_MODEL" in
346 346 0)
347 347 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
348 348 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
349 349 ;;
350 350 1)
351 351 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
352 352 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
353 353 ;;
354 354 1P)
355 355 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
356 356 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
357 357 ;;
358 358 2)
359 359 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
360 360 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
361 361 ;;
362 362 3)
363 363 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
364 364 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
365 365 ;;
366 366 3P)
367 367 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
368 368 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
369 369 ;;
370 370 4)
371 371 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
372 372 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
373 373 ;;
374 374 *)
375 375 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
376 376 exit 1
377 377 ;;
378 378 esac
379 379
380 380 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
381 381 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
382 382 # Include bluetooth packages on supported boards
383 383 if [ "$ENABLE_BLUETOOTH" = true ] ; then
384 384 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
385 385 fi
386 386 if [ "$ENABLE_WIRELESS" = true ] ; then
387 387 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
388 388 fi
389 389 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
390 390 # Check if the internal wireless interface is not supported by the RPi model
391 391 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
392 392 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
393 393 exit 1
394 394 fi
395 395 fi
396 396
397 397 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
398 398 echo "error: You have to compile kernel sources, if you want to enable nexmon"
399 399 exit 1
400 400 fi
401 401
402 402 # Prepare date string for default image file name
403 403 DATE="$(date +%Y-%m-%d)"
404 404 if [ -z "$KERNEL_BRANCH" ] ; then
405 405 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
406 406 else
407 407 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
408 408 fi
409 409
410 410 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
411 411 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
412 412 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
413 413 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
414 414 exit 1
415 415 fi
416 416 fi
417 417
418 418 # Add cmake to compile videocore sources
419 419 if [ "$ENABLE_VIDEOCORE" = true ] ; then
420 420 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
421 421 fi
422 422
423 423 # Add deps for nexmon
424 424 if [ "$ENABLE_NEXMON" = true ] ; then
425 425 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
426 426 fi
427 427
428 428 # Add libncurses5 to enable kernel menuconfig
429 429 if [ "$KERNEL_MENUCONFIG" = true ] ; then
430 430 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
431 431 fi
432 432
433 433 # Add ccache compiler cache for (faster) kernel cross (re)compilation
434 434 if [ "$KERNEL_CCACHE" = true ] ; then
435 435 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
436 436 fi
437 437
438 438 # Add cryptsetup package to enable filesystem encryption
439 439 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
440 440 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
441 441 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
442 442
443 443 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
444 444 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
445 445 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
446 446 fi
447 447
448 448 if [ -z "$CRYPTFS_PASSWORD" ] ; then
449 449 echo "error: no password defined (CRYPTFS_PASSWORD)!"
450 450 exit 1
451 451 fi
452 452 ENABLE_INITRAMFS=true
453 453 fi
454 454
455 455 # Add initramfs generation tools
456 456 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
457 457 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
458 458 fi
459 459
460 460 # Add device-tree-compiler required for building the U-Boot bootloader
461 461 if [ "$ENABLE_UBOOT" = true ] ; then
462 462 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
463 463 fi
464 464
465 465 if [ "$ENABLE_USBBOOT" = true ] ; then
466 466 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
467 467 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
468 468 exit 1
469 469 fi
470 470 fi
471 471
472 472 # Check if root SSH (v2) public key file exists
473 473 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
474 474 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
475 475 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
476 476 exit 1
477 477 fi
478 478 fi
479 479
480 480 # Check if $USER_NAME SSH (v2) public key file exists
481 481 if [ -n "$SSH_USER_PUB_KEY" ] ; then
482 482 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
483 483 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
484 484 exit 1
485 485 fi
486 486 fi
487 487
488 488 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
489 489 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
490 490 exit 1
491 491 fi
492 492
493 493 # Check if all required packages are installed on the build system
494 494 for package in $REQUIRED_PACKAGES ; do
495 495 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
496 496 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
497 497 fi
498 498 done
499 499
500 500 # If there are missing packages ask confirmation for install, or exit
501 501 if [ -n "$MISSING_PACKAGES" ] ; then
502 502 echo "the following packages needed by this script are not installed:"
503 503 echo "$MISSING_PACKAGES"
504 504
505 505 printf "\ndo you want to install the missing packages right now? [y/n] "
506 506 read -r confirm
507 507 [ "$confirm" != "y" ] && exit 1
508 508
509 509 # Make sure all missing required packages are installed
510 510 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
511 511 fi
512 512
513 513 # Check if ./bootstrap.d directory exists
514 514 if [ ! -d "./bootstrap.d/" ] ; then
515 515 echo "error: './bootstrap.d' required directory not found!"
516 516 exit 1
517 517 fi
518 518
519 519 # Check if ./files directory exists
520 520 if [ ! -d "./files/" ] ; then
521 521 echo "error: './files' required directory not found!"
522 522 exit 1
523 523 fi
524 524
525 525 # Check if specified KERNELSRC_DIR directory exists
526 526 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
527 527 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
528 528 exit 1
529 529 fi
530 530
531 531 # Check if specified UBOOTSRC_DIR directory exists
532 532 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
533 533 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
534 534 exit 1
535 535 fi
536 536
537 537 # Check if specified VIDEOCORESRC_DIR directory exists
538 538 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
539 539 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
540 540 exit 1
541 541 fi
542 542
543 543 # Check if specified FBTURBOSRC_DIR directory exists
544 544 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
545 545 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
546 546 exit 1
547 547 fi
548 548
549 549 # Check if specified NEXMONSRC_DIR directory exists
550 550 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
551 551 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
552 552 exit 1
553 553 fi
554 554
555 555 # Check if specified CHROOT_SCRIPTS directory exists
556 556 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
557 557 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
558 558 exit 1
559 559 fi
560 560
561 561 # Check if specified device mapping already exists (will be used by cryptsetup)
562 562 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
563 563 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
564 564 exit 1
565 565 fi
566 566
567 567 # Don't clobber an old build
568 568 if [ -e "$BUILDDIR" ] ; then
569 569 echo "error: directory ${BUILDDIR} already exists, not proceeding"
570 570 exit 1
571 571 fi
572 572
573 573 # Setup chroot directory
574 574 mkdir -p "${R}"
575 575
576 576 # Check if build directory has enough of free disk space >512MB
577 577 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
578 578 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
579 579 exit 1
580 580 fi
581 581
582 582 set -x
583 583
584 584 # Call "cleanup" function on various signals and errors
585 585 trap cleanup 0 1 2 3 6
586 586
587 587 # Add required packages for the minbase installation
588 588 if [ "$ENABLE_MINBASE" = true ] ; then
589 589 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
590 590 fi
591 591
592 592 # Add parted package, required to get partprobe utility
593 593 if [ "$EXPANDROOT" = true ] ; then
594 594 APT_INCLUDES="${APT_INCLUDES},parted"
595 595 fi
596 596
597 597 # Add dphys-swapfile package, required to enable swap
598 598 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
599 599 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
600 600 fi
601 601
602 602 # Add dbus package, recommended if using systemd
603 603 if [ "$ENABLE_DBUS" = true ] ; then
604 604 APT_INCLUDES="${APT_INCLUDES},dbus"
605 605 fi
606 606
607 607 # Add iptables IPv4/IPv6 package
608 608 if [ "$ENABLE_IPTABLES" = true ] ; then
609 609 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
610 610 fi
611 611 # Add apparmor for KERNEL_SECURITY
612 612 if [ "$KERNEL_SECURITY" = true ] ; then
613 613 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
614 614 fi
615 615
616 616 # Add openssh server package
617 617 if [ "$SSH_ENABLE" = true ] ; then
618 618 APT_INCLUDES="${APT_INCLUDES},openssh-server"
619 619 fi
620 620
621 621 # Add alsa-utils package
622 622 if [ "$ENABLE_SOUND" = true ] ; then
623 623 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
624 624 fi
625 625
626 626 # Add rng-tools package
627 627 if [ "$ENABLE_HWRANDOM" = true ] ; then
628 628 APT_INCLUDES="${APT_INCLUDES},rng-tools"
629 629 fi
630 630
631 631 # Add fbturbo video driver
632 632 if [ "$ENABLE_FBTURBO" = true ] ; then
633 633 # Enable xorg package dependencies
634 634 ENABLE_XORG=true
635 635 fi
636 636
637 637 # Add user defined window manager package
638 638 if [ -n "$ENABLE_WM" ] ; then
639 639 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
640 640
641 641 # Enable xorg package dependencies
642 642 ENABLE_XORG=true
643 643 fi
644 644
645 645 # Add xorg package
646 646 if [ "$ENABLE_XORG" = true ] ; then
647 647 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
648 648 fi
649 649
650 650 # Replace selected packages with smaller clones
651 651 if [ "$ENABLE_REDUCE" = true ] ; then
652 652 # Add levee package instead of vim-tiny
653 653 if [ "$REDUCE_VIM" = true ] ; then
654 654 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
655 655 fi
656 656
657 657 # Add dropbear package instead of openssh-server
658 658 if [ "$REDUCE_SSHD" = true ] ; then
659 659 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
660 660 fi
661 661 fi
662 662
663 663 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
664 664 if [ "$ENABLE_SYSVINIT" = false ] ; then
665 665 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
666 666 fi
667 667
668 668 # Configure kernel sources if no KERNELSRC_DIR
669 669 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
670 670 KERNELSRC_CONFIG=true
671 671 fi
672 672
673 673 # Configure reduced kernel
674 674 if [ "$KERNEL_REDUCE" = true ] ; then
675 675 KERNELSRC_CONFIG=false
676 676 fi
677 677
678 678 # Configure qemu compatible kernel
679 679 if [ "$ENABLE_QEMU" = true ] ; then
680 680 DTB_FILE=vexpress-v2p-ca15_a7.dtb
681 681 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
682 682 KERNEL_DEFCONFIG="vexpress_defconfig"
683 683 if [ "$KERNEL_MENUCONFIG" = false ] ; then
684 684 KERNEL_OLDDEFCONFIG=true
685 685 fi
686 686 fi
687 687
688 688 # Execute bootstrap scripts
689 689 for SCRIPT in bootstrap.d/*.sh; do
690 690 head -n 3 "$SCRIPT"
691 691 . "$SCRIPT"
692 692 done
693 693
694 694 ## Execute custom bootstrap scripts
695 695 if [ -d "custom.d" ] ; then
696 696 for SCRIPT in custom.d/*.sh; do
697 697 . "$SCRIPT"
698 698 done
699 699 fi
700 700
701 701 # Execute custom scripts inside the chroot
702 702 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
703 703 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
704 704 chroot_exec /bin/bash -x <<'EOF'
705 705 for SCRIPT in /chroot_scripts/* ; do
706 706 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
707 707 $SCRIPT
708 708 fi
709 709 done
710 710 EOF
711 711 rm -rf "${R}/chroot_scripts"
712 712 fi
713 713
714 714 # Remove c/c++ build environment from the chroot
715 715 chroot_remove_cc
716 716
717 717 # Generate required machine-id
718 718 MACHINE_ID=$(dbus-uuidgen)
719 719 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
720 720 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
721 721
722 722 # APT Cleanup
723 723 chroot_exec apt-get -y clean
724 724 chroot_exec apt-get -y autoclean
725 725 chroot_exec apt-get -y autoremove
726 726
727 727 # Unmount mounted filesystems
728 728 umount -l "${R}/proc"
729 729 umount -l "${R}/sys"
730 730
731 731 # Clean up directories
732 732 rm -rf "${R}/run/*"
733 733 rm -rf "${R}/tmp/*"
734 734
735 735 # Clean up APT proxy settings
736 736 if [ "$KEEP_APT_PROXY" = false ] ; then
737 737 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
738 738 fi
739 739
740 740 # Clean up files
741 741 rm -f "${ETC_DIR}/ssh/ssh_host_*"
742 742 rm -f "${ETC_DIR}/dropbear/dropbear_*"
743 743 rm -f "${ETC_DIR}/apt/sources.list.save"
744 744 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
745 745 rm -f "${ETC_DIR}/*-"
746 746 rm -f "${ETC_DIR}/resolv.conf"
747 747 rm -f "${R}/root/.bash_history"
748 748 rm -f "${R}/var/lib/urandom/random-seed"
749 749 rm -f "${R}/initrd.img"
750 750 rm -f "${R}/vmlinuz"
751 751 rm -f "${R}${QEMU_BINARY}"
752 752
753 753 if [ "$ENABLE_QEMU" = true ] ; then
754 754 # Setup QEMU directory
755 755 mkdir "${BASEDIR}/qemu"
756 756
757 757 # Copy kernel image to QEMU directory
758 758 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
759 759
760 760 # Copy kernel config to QEMU directory
761 761 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
762 762
763 763 # Copy kernel dtbs to QEMU directory
764 764 for dtb in "${BOOT_DIR}/"*.dtb ; do
765 765 if [ -f "${dtb}" ] ; then
766 766 install_readonly "${dtb}" "${BASEDIR}/qemu/"
767 767 fi
768 768 done
769 769
770 770 # Copy kernel overlays to QEMU directory
771 771 if [ -d "${BOOT_DIR}/overlays" ] ; then
772 772 # Setup overlays dtbs directory
773 773 mkdir "${BASEDIR}/qemu/overlays"
774 774
775 775 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
776 776 if [ -f "${dtb}" ] ; then
777 777 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
778 778 fi
779 779 done
780 780 fi
781 781
782 782 # Copy u-boot files to QEMU directory
783 783 if [ "$ENABLE_UBOOT" = true ] ; then
784 784 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
785 785 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
786 786 fi
787 787 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
788 788 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
789 789 fi
790 790 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
791 791 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
792 792 fi
793 793 fi
794 794
795 795 # Copy initramfs to QEMU directory
796 796 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
797 797 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
798 798 fi
799 799 fi
800 800
801 801 # Calculate size of the chroot directory in KB
802 802 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
803 803
804 804 # Calculate the amount of needed 512 Byte sectors
805 805 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
806 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
806 FRMW_SECTORS=$(expr 128 \* 1024 \* 1024 \/ 512)
807 807 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
808 808
809 809 # The root partition is EXT4
810 810 # This means more space than the actual used space of the chroot is used.
811 811 # As overhead for journaling and reserved blocks 35% are added.
812 812 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
813 813
814 814 # Calculate required image size in 512 Byte sectors
815 815 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
816 816
817 817 # Prepare image file
818 818 if [ "$ENABLE_SPLITFS" = true ] ; then
819 819 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
820 820 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
821 821 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
822 822 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
823 823
824 824 # Write firmware/boot partition tables
825 825 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
826 826 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
827 827 EOM
828 828
829 829 # Write root partition table
830 830 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
831 831 ${TABLE_SECTORS},${ROOT_SECTORS},83
832 832 EOM
833 833
834 834 # Setup temporary loop devices
835 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
835 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME"-frmw.img)"
836 836 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
837 837 else # ENABLE_SPLITFS=false
838 838 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
839 839 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
840 840
841 841 # Write partition table
842 842 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
843 843 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
844 844 ${ROOT_OFFSET},${ROOT_SECTORS},83
845 845 EOM
846 846
847 847 # Setup temporary loop devices
848 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
849 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
848 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME".img)"
849 ROOT_LOOP="$(losetup -o 129M -f --show "$IMAGE_NAME".img)"
850 850 fi
851 851
852 852 if [ "$ENABLE_CRYPTFS" = true ] ; then
853 853 # Create dummy ext4 fs
854 854 mkfs.ext4 "$ROOT_LOOP"
855 855
856 856 # Setup password keyfile
857 857 touch .password
858 858 chmod 600 .password
859 859 echo -n ${CRYPTFS_PASSWORD} > .password
860 860
861 861 # Initialize encrypted partition
862 862 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
863 863
864 864 # Open encrypted partition and setup mapping
865 865 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
866 866
867 867 # Secure delete password keyfile
868 868 shred -zu .password
869 869
870 870 # Update temporary loop device
871 871 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
872 872
873 873 # Wipe encrypted partition (encryption cipher is used for randomness)
874 874 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
875 875 fi
876 876
877 877 # Build filesystems
878 878 mkfs.vfat "$FRMW_LOOP"
879 879 mkfs.ext4 "$ROOT_LOOP"
880 880
881 881 # Mount the temporary loop devices
882 882 mkdir -p "$BUILDDIR/mount"
883 883 mount "$ROOT_LOOP" "$BUILDDIR/mount"
884 884
885 885 mkdir -p "$BUILDDIR/mount/boot/firmware"
886 886 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
887 887
888 888 # Copy all files from the chroot to the loop device mount point directory
889 889 rsync -a "${R}/" "$BUILDDIR/mount/"
890 890
891 891 # Unmount all temporary loop devices and mount points
892 892 cleanup
893 893
894 894 # Create block map file(s) of image(s)
895 895 if [ "$ENABLE_SPLITFS" = true ] ; then
896 896 # Create block map files for "bmaptool"
897 897 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
898 898 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
899 899
900 900 # Image was successfully created
901 901 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
902 902 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
903 903 else
904 904 # Create block map file for "bmaptool"
905 905 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
906 906
907 907 # Image was successfully created
908 908 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
909 909
910 910 # Create qemu qcow2 image
911 911 if [ "$ENABLE_QEMU" = true ] ; then
912 912 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
913 913 QEMU_SIZE=16G
914 914
915 915 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
916 916 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
917 917
918 918 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
919 919 fi
920 920 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant